﻿using System;
using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 태스크
    /// </summary>
    public class Task
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ID - ID

        /// <summary>
        /// ID
        /// </summary>
        public int ID { get; set; }

        #endregion
        #region 부모 ID - ParentID

        /// <summary>
        /// 부모 ID
        /// </summary>
        public int ParentID { get; set; }

        #endregion
        #region 작업명 - Name

        /// <summary>
        /// 작업명
        /// </summary>
        public string Name { get; set; }

        #endregion
        #region 시작일 - StartDate

        /// <summary>
        /// 시작일
        /// </summary>
        public DateTime StartDate { get; set; }

        #endregion
        #region 종료일 - EndDate

        /// <summary>
        /// 종료일
        /// </summary>
        public DateTime EndDate { get; set; }

        #endregion
        #region 진행률 - Progress

        /// <summary>
        /// 진행률
        /// </summary>
        public double? Progress { get; set; }

        #endregion
        #region 담당자 - Charger

        /// <summary>
        /// 담당자
        /// </summary>
        public string Charger { get; set; }

        #endregion
        #region 이전 ID 리스트 - PreviousIDList

        /// <summary>
        /// 이전 ID 리스트
        /// </summary>
        public List<int> PreviousIDList { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 리스트 구하기 - GetList()

        /// <summary>
        /// 리스트 구하기
        /// </summary>
        /// <returns>리스트</returns>
        public static List<Task> GetList()
        {
            List<Task> list = new List<Task>();

            list.Add(GetTask(1, 0, "작업 1"  , new DateTime(2020, 2, 1 ), new DateTime(2020, 2, 29), null, null               ));
            list.Add(GetTask(2, 1, "작업 1-1", new DateTime(2020, 2, 1 ), new DateTime(2020, 2, 10), 10  , null               ));
            list.Add(GetTask(3, 1, "작업 1-2", new DateTime(2020, 2, 10), new DateTime(2020, 2, 20), 20  , new List<int> { 2 }));
            list.Add(GetTask(4, 1, "작업 1-3", new DateTime(2020, 2, 20), new DateTime(2020, 2, 29), 30  , new List<int> { 3 }));
            list.Add(GetTask(5, 1, "완료 1"  , new DateTime(2020, 2, 29), new DateTime(2020, 2, 29), null, new List<int> { 4 }));
            list.Add(GetTask(6, 0, "작업 2"  , new DateTime(2020, 3, 1 ), new DateTime(2020, 3, 31), null, null               ));
            list.Add(GetTask(7, 6, "작업 2-1", new DateTime(2020, 3, 1 ), new DateTime(2020, 3, 10), null, new List<int> { 5 }));
            list.Add(GetTask(8, 6, "작업 2-2", new DateTime(2020, 3, 10), new DateTime(2020, 3, 20), null, new List<int> { 7 }));

            return list;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region 태스크 구하기 - GetTask(id, parentID, name, startDate, endDate, progress, previoudIDList)

        /// <summary>
        /// 태스크 구하기
        /// </summary>
        /// <param name="id">ID</param>
        /// <param name="parentID">부모 ID</param>
        /// <param name="name">작업명</param>
        /// <param name="startDate">시작일</param>
        /// <param name="endDate">종료일</param>
        /// <param name="progress">진행률</param>
        /// <param name="previoudIDList">이전 ID List</param>
        /// <returns></returns>
        private static Task GetTask(int id, int parentID, string name, DateTime startDate, DateTime endDate, double? progress, List<int> previoudIDList)
        {
            Task task = new Task();

            task.ID             = id;
            task.ParentID       = parentID;
            task.Name           = name;
            task.StartDate      = startDate;
            task.EndDate        = endDate;
            task.Progress       = progress;
            task.PreviousIDList = previoudIDList;

            return task;
        }

        #endregion
    }
}